;The TTP Project Boot Loader 0.3.2
;Copyright 2000-2001 Leif Ames and Michael Benoit
;Based on the RavenOS Boot Sector 0.1.0

org 0                            ;We don't want NASM to mess with our addresses
jmp Start                          ;Keep the GDT and other data from being executed
%include"gdt.inc"
%include"8259.asm"
%include"n2o.asm"
%include "loadk.asm"
%include "ssetup.asm"

msg1
	db 13,10,'Initalizing the PIC...'      ; 24 chars total
msg2 
	db 13,10,'Enabling A20...   '          ; 20 chars total
msg3
	db 13,10,'Initalizing PMODE and booting The TTP Project...',13,10,13,10   ; 53 chars
bootdrv
	db 0h

[bits 16]
Start:                         
	mov [bootdrv],dl        ;Move the bootdrive id into bootdrv
	mov ax, 0x7c0          ;Load 0x7c0 in to DS
	mov ds, ax             ;Not sure why, but the 486 needs this...
	
	call stacksetup
	
	mov ah, 0x03
	xor bh, bh
	int 0x10
	mov cx, 24
	mov bx, 0x0007
	mov bp, msg1
	mov ax, 0x07c0
	push es
	mov es, ax
	mov ax, 0x1301
	int 0x10
	pop es
	call pic
	mov ah, 0x03
	xor bh, bh
	int 0x10
	mov cx, 20
	mov bx, 0x0007
	mov bp, msg2
	mov ax, 0x07c0
	push es
	mov es, ax
	mov ax, 0x1301
	int 0x10
	pop es
	call A20
	call loadfile
	mov ah, 0x03
	xor bh, bh
	int 0x10
	mov cx, 54
	mov bx, 0x0007
	mov ax, 0x07c0
	push es
	mov es, ax
	mov bp, msg3
	mov ax, 0x1301
	int 0x10
	pop es

	cli                    ;Mask interupts
	mov al, 0x80           ;Stop NMIs as well
	out 0x70, al
	lgdt [gdt+2]           ;Load the gdt!
gopm:
	mov eax, cr0           ;Copy Control Register 0 into EAX
      or al,1                ;Increment EAX (PMODE enable bit now 1)
      mov cr0, eax           ;Copy EAX into Control Register 0
	jmp short $+2          ;JMP to next line (Clear prefetch queue)
	jmp 0x08:pmode+7c00h   ;JMP to the 32 bit code!

	
[bits 32]
pmode:                         ;Should be in PMODE now...
	mov ax, 0x10           ;Select data descriptor   
	mov ds, ax                
	mov [0xB8000], word 0x0154 ;stuff
	mov [0xB8002], word 0x0154
	mov [0xB8004], word 0x0150
	jmp DWORD  0x08:0x10000  
	  jmp short $                ;Sit and do nothing (infinite Loop)

	times 510-($-$$) db 0  ;Move to offset 510 in the BS
	dw 0xAA55              ;Boot Sector identifier
